# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from marti_dbw_msgs/PrimaryFeedback.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class PrimaryFeedback(genpy.Message):
  _md5sum = "30a7ed1579a7c53a676c3444badef268"
  _type = "marti_dbw_msgs/PrimaryFeedback"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """std_msgs/Header header

bool present
# Boolean flag indicating that DBW system is present and communicating
# properly.  If this is false, none of the remaining data in the
# feedback can be considered valid.

# Boolean flag indicating that DBW system is in robotic mode.
bool robotic_mode

float32 steering_command
float32 steering_measure
# The current steering command and measured value of the steering
# axies in the range [0.0 to 1.0].  Typically 0.0 is full left and 1.0
# is full right, but the steering calibration can handle either
# direction.

float32 throttle_command
float32 throttle_measure
# The current throttle command and measured value of the throttle
# control in the range [0.0 to 1.0]

float32 brake_command
float32 brake_measure
# The current throttle command and measured value of the throttle
# control in the range [0.0 to 1.0]

bool estop_command
bool estop_measure

bool error_steering
bool error_throttle
bool error_brake
bool error_other

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['header','present','robotic_mode','steering_command','steering_measure','throttle_command','throttle_measure','brake_command','brake_measure','estop_command','estop_measure','error_steering','error_throttle','error_brake','error_other']
  _slot_types = ['std_msgs/Header','bool','bool','float32','float32','float32','float32','float32','float32','bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,present,robotic_mode,steering_command,steering_measure,throttle_command,throttle_measure,brake_command,brake_measure,estop_command,estop_measure,error_steering,error_throttle,error_brake,error_other

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(PrimaryFeedback, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.present is None:
        self.present = False
      if self.robotic_mode is None:
        self.robotic_mode = False
      if self.steering_command is None:
        self.steering_command = 0.
      if self.steering_measure is None:
        self.steering_measure = 0.
      if self.throttle_command is None:
        self.throttle_command = 0.
      if self.throttle_measure is None:
        self.throttle_measure = 0.
      if self.brake_command is None:
        self.brake_command = 0.
      if self.brake_measure is None:
        self.brake_measure = 0.
      if self.estop_command is None:
        self.estop_command = False
      if self.estop_measure is None:
        self.estop_measure = False
      if self.error_steering is None:
        self.error_steering = False
      if self.error_throttle is None:
        self.error_throttle = False
      if self.error_brake is None:
        self.error_brake = False
      if self.error_other is None:
        self.error_other = False
    else:
      self.header = std_msgs.msg.Header()
      self.present = False
      self.robotic_mode = False
      self.steering_command = 0.
      self.steering_measure = 0.
      self.throttle_command = 0.
      self.throttle_measure = 0.
      self.brake_command = 0.
      self.brake_measure = 0.
      self.estop_command = False
      self.estop_measure = False
      self.error_steering = False
      self.error_throttle = False
      self.error_brake = False
      self.error_other = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B6f6B().pack(_x.present, _x.robotic_mode, _x.steering_command, _x.steering_measure, _x.throttle_command, _x.throttle_measure, _x.brake_command, _x.brake_measure, _x.estop_command, _x.estop_measure, _x.error_steering, _x.error_throttle, _x.error_brake, _x.error_other))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.present, _x.robotic_mode, _x.steering_command, _x.steering_measure, _x.throttle_command, _x.throttle_measure, _x.brake_command, _x.brake_measure, _x.estop_command, _x.estop_measure, _x.error_steering, _x.error_throttle, _x.error_brake, _x.error_other,) = _get_struct_2B6f6B().unpack(str[start:end])
      self.present = bool(self.present)
      self.robotic_mode = bool(self.robotic_mode)
      self.estop_command = bool(self.estop_command)
      self.estop_measure = bool(self.estop_measure)
      self.error_steering = bool(self.error_steering)
      self.error_throttle = bool(self.error_throttle)
      self.error_brake = bool(self.error_brake)
      self.error_other = bool(self.error_other)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2B6f6B().pack(_x.present, _x.robotic_mode, _x.steering_command, _x.steering_measure, _x.throttle_command, _x.throttle_measure, _x.brake_command, _x.brake_measure, _x.estop_command, _x.estop_measure, _x.error_steering, _x.error_throttle, _x.error_brake, _x.error_other))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 32
      (_x.present, _x.robotic_mode, _x.steering_command, _x.steering_measure, _x.throttle_command, _x.throttle_measure, _x.brake_command, _x.brake_measure, _x.estop_command, _x.estop_measure, _x.error_steering, _x.error_throttle, _x.error_brake, _x.error_other,) = _get_struct_2B6f6B().unpack(str[start:end])
      self.present = bool(self.present)
      self.robotic_mode = bool(self.robotic_mode)
      self.estop_command = bool(self.estop_command)
      self.estop_measure = bool(self.estop_measure)
      self.error_steering = bool(self.error_steering)
      self.error_throttle = bool(self.error_throttle)
      self.error_brake = bool(self.error_brake)
      self.error_other = bool(self.error_other)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B6f6B = None
def _get_struct_2B6f6B():
    global _struct_2B6f6B
    if _struct_2B6f6B is None:
        _struct_2B6f6B = struct.Struct("<2B6f6B")
    return _struct_2B6f6B
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
